<template>
  <v-layout>
    <v-flex>
      <v-layout class="justify-space-between no-wrap">
        <template v-for="status in statuses">
          <v-card
            :key="status.alias"
            width="120px"
            height="110px"
            class="text-xs-center"
            @click="changeStatus(status.alias)"
          >
            <v-icon large color="green darken-2" class="mt-4">{{status.icon}}</v-icon>
            <br>
            <span class="font-weight-thin">{{status.name}}</span>
          </v-card>
        </template>
      </v-layout>
      <br>
      <h2>Исполенные</h2>
      <br>
      <v-layout class="full-height" column>
        <v-data-table
          :headers="headers"
          :items="tasks"
          no-data-text="Нет доступных жалоб"
          class="elevation-1"
        >
          <template v-slot:items="props">
            <td class="text-xs-left">{{
              timestampToDateTime(props.item.createdAt) }}
            </td>
            <td class="text-xs-left">14.737699 <br> 26.657728</td>
            <td class="text-xs-left">{{ props.item.type.name }}</td>
            <td class="text-xs-left">
              {{
              (props.item.executor) ? props.item.executor.username: ''
              }}
            </td>
            <td class="text-xs-left">{{ props.item.deadlineAt }}</td>
            <td class="text-xs-left">
              {{ $t('statuses.'+props.item.status) }}
            </td>
            <td class="text-xs-left">{{ props.item.scoreTotal }} звезды</td>
          </template>
        </v-data-table>
      </v-layout>
    </v-flex>
  </v-layout>
</template>

<script>
  import FloatingButton from '@/components/base/FloatingButton'
  import CreateTask from '@/views/tasks/CreateTask'
  import BaseButton from '@/components/base/Button'
  import { mapActions } from 'vuex'
  import { TaskModel } from '@/models/TaskModel'
  import { paginationFunctions } from '@/utils/paginationFunctions'
  import * as moment from 'moment'

  /**
   * @name Tasks
   * @mixes Vue
   */
  export default {
    name: 'Tasks',
    components: { BaseButton, CreateTask, FloatingButton },
    data () {
      return {
        headers: [
          { text: 'Получено', value: 'received' },
          { text: 'Локация', value: 'location' },
          { text: 'Тип жалобы', value: 'type' },
          { text: 'Исполнитель', value: 'executor' },
          { text: 'Дедлайн', value: 'deadlineAt' },
          { text: 'Статус', value: 'status' },
          { text: 'Оценка', value: 'estimate' }
        ],
        statuses: TaskModel.getStatuses(),
        filters: TaskModel.getFilters()
      }
    },
    computed: {
      tasks () {
        return this.$store.getters.tasks;
      }
    },
    methods: {
      ...mapActions([
        'getAllTasks',
        'saveTask'
      ]),
      changeStatus (status) {
        this.filters.status = status
      },
      timestampToDateTime (timestamp) {
        if (timestamp !== undefined) {
          return moment.unix(timestamp).format('hh:mm DD.MM.YYYY')
        }
      }
    },
    watch: {
      filters: {
        handler (filters) {
          const pagination = paginationFunctions(filters.page, filters.limit);
          this.getAllTasks(Object.assign(filters, pagination));
        },
        deep: true
      }
    },
    async mounted () {
      this.$store.commit('cleanTasks');
      await this.getAllTasks(this.filters);
    }
  }
</script>
